<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />

  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.0/css/all.css" integrity="sha384-lZN37f5QGtY3VHgisS14W3ExzMWZxybE1SJSEsQp9S+oqd12jhcu+A56Ebc1zFSJ" crossorigin="anonymous">

  <title>Submitting a Function to the DANTE Project</title>
  <style>
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>

  <style>
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(data-line-number);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>

  <link rel="stylesheet" href="/usr/local/lib/R/site-library/danteSubmit/rmarkdown/templates/dante_vignette/resources/style.css" />

  <!--[if lt IE 9]>
    <script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/3.7.3/html5shiv-printshiv.min.js"></script>
  <![endif]-->
</head>

<body>

<header id="title-block-header">
<h1 class="title">Submitting a Function to the DANTE Project</h1>

<p class="date" id="date"><em>2019-09-10</em></p>

<div id="author-block">
<span id="author-name">Joshua Brinks</span>,&nbsp;<span id="author-affiliation"><em>ISciences, LLC</em>&nbsp;<sup><a id="author-email" href="mailto:jbrinks@isciences.com"><i class="far fa-envelope" style="font-size:15px; color: blue"></i></a></sup></br>
</div>




</header>

<h3> Contents: </h3>
<nav id="TOC" role="doc-toc">
<ul>
<li><a href="#introduction"><span class="toc-section-number">1</span> Introduction</a></li>
<li><a href="#r-style"><span class="toc-section-number">2</span> R Style</a></li>
<li><a href="#documenting-functions"><span class="toc-section-number">3</span> Documenting Functions</a></li>
</ul>
</nav>

<div id="introduction" class="section level1">
<h1><span class="header-section-number">1</span> Introduction</h1>
<p>The DANTE Project provides an open source community platform to lower the barriers of entry to climate security research and policy making. One of the core components of the project are user submitted functions. Function submitted to the DANTE Project may tackle a wide variety of tasks, but the ultimate goal is to reduce barriers to entry, time sinks, and reduntant operations in climate-security research. These may include, but are not limited to:</p>
<ul>
<li>Data acquisition.</li>
<li>Correcting typos, missing data, or other errors in the native dataset.</li>
<li>Introducing common country codes and schemes.</li>
<li>Filtering data by countries, years, or other thresholds.</li>
<li>Simple plotting functions with modern aesthetics and dynamic labeling.</li>
<li>Wrappers for more complex plotting functions such as geo-rectified network plots or chord diagrams.</li>
<li>Automated summary reports or dashboard views.</li>
<li>Open source data distribution.</li>
</ul>
</div>
<div id="r-style" class="section level1">
<h1><span class="header-section-number">2</span> R Style</h1>
<p>Functions submitted to DANTE should follow generally accepted R style. <a href="https://google.github.io/styleguide/Rguide.xml">Google’s R Style</a> guide or <a href="https://style.tidyverse.org/">The Tidyverse Style Guide</a> are good starting points. If you choose to deviate from established frameworks the most important thing is to be consistent. Generally speaking follow these basic rules:</p>
<ul>
<li>Variable names and object should be lower case with words being separated by only a period or underscore.</li>
</ul>
<div class="sourceCode" id="cb1"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb1-1" data-line-number="1"><span class="co"># Proper</span></a>
<a class="sourceLine" id="cb1-2" data-line-number="2">good.name</a>
<a class="sourceLine" id="cb1-3" data-line-number="3">good_name</a>
<a class="sourceLine" id="cb1-4" data-line-number="4"></a>
<a class="sourceLine" id="cb1-5" data-line-number="5"><span class="co"># Improper</span></a>
<a class="sourceLine" id="cb1-6" data-line-number="6">BADNAME</a>
<a class="sourceLine" id="cb1-7" data-line-number="7">AnotherBadname</a></code></pre></div>
<ul>
<li>Function names should be concise and written in CamelCase. Function names are typically verbs.</li>
</ul>
<div class="sourceCode" id="cb2"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb2-1" data-line-number="1"><span class="co"># Proper</span></a>
<a class="sourceLine" id="cb2-2" data-line-number="2"><span class="kw">getData</span>()</a>
<a class="sourceLine" id="cb2-3" data-line-number="3"><span class="kw">prepData</span>()</a>
<a class="sourceLine" id="cb2-4" data-line-number="4"></a>
<a class="sourceLine" id="cb2-5" data-line-number="5"><span class="co"># Improper</span></a>
<a class="sourceLine" id="cb2-6" data-line-number="6"><span class="kw">bad.Data</span>()</a>
<a class="sourceLine" id="cb2-7" data-line-number="7"><span class="kw">EVEN_worse_FUNCTION</span>()</a></code></pre></div>
<ul>
<li>Function arguments should be lower case with multi-word functions utilizing a period or underscore.</li>
</ul>
<div class="sourceCode" id="cb3"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb3-1" data-line-number="1"><span class="co"># Good Arguments</span></a>
<a class="sourceLine" id="cb3-2" data-line-number="2"><span class="kw">getData</span>(x, <span class="dt">save.raw =</span> <span class="ot">TRUE</span>)</a>
<a class="sourceLine" id="cb3-3" data-line-number="3"><span class="kw">getData</span>(x, <span class="dt">save_raw =</span> <span class="ot">TRUE</span>)</a>
<a class="sourceLine" id="cb3-4" data-line-number="4"></a>
<a class="sourceLine" id="cb3-5" data-line-number="5"><span class="co"># Bad Arguments</span></a>
<a class="sourceLine" id="cb3-6" data-line-number="6"><span class="kw">getData</span>(x, <span class="dt">saveRaw =</span> <span class="ot">TRUE</span>)</a>
<a class="sourceLine" id="cb3-7" data-line-number="7"><span class="kw">getData</span>(x, <span class="dt">SAVERAW =</span> <span class="ot">TRUE</span>)</a></code></pre></div>
<p>Refer to one of the aforementioned guides for more intricate styling of spacing, assignments, curly brackets, <code>if</code> and <code>ifelse</code> statements, quotation useage, comments, and a variety of other more nuanced style issues.</p>
</div>
<div id="documenting-functions" class="section level1">
<h1><span class="header-section-number">3</span> Documenting Functions</h1>
<p>All submitted functions should be properly documented so they may easily be bundled into packages. Function and package documentation in R is simplified with RStudio and <a href="https://cran.r-project.org/web/packages/roxygen2/vignettes/roxygen2.html"><code>roxygen2</code></a>. After developing and testing your function, and with the cursor situated on your function name inside the script, insert the roxygen2 documentation skeleton in RStudio with <code>Menu &gt; Code &gt; Insert Roxygen Skeleton</code>.</p>
<p><img src="insert_roxy.png" /></p>
<p>This will introduce several lines of commented code to build the help file associated with your function.</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb4-1" data-line-number="1"><span class="co">#&#39; Title</span></a>
<a class="sourceLine" id="cb4-2" data-line-number="2"><span class="co">#&#39;</span></a>
<a class="sourceLine" id="cb4-3" data-line-number="3"><span class="co">#&#39; @param x </span></a>
<a class="sourceLine" id="cb4-4" data-line-number="4"><span class="co">#&#39; @param save.raw </span></a>
<a class="sourceLine" id="cb4-5" data-line-number="5"><span class="co">#&#39;</span></a>
<a class="sourceLine" id="cb4-6" data-line-number="6"><span class="co">#&#39; @return</span></a>
<a class="sourceLine" id="cb4-7" data-line-number="7"><span class="co">#&#39; @export</span></a>
<a class="sourceLine" id="cb4-8" data-line-number="8"><span class="co">#&#39;</span></a>
<a class="sourceLine" id="cb4-9" data-line-number="9"><span class="co">#&#39; @examples</span></a>
<a class="sourceLine" id="cb4-10" data-line-number="10">getData&lt;-<span class="cf">function</span>(x, <span class="dt">save.raw =</span> <span class="ot">TRUE</span>){</a>
<a class="sourceLine" id="cb4-11" data-line-number="11">  x&lt;-data.table<span class="op">::</span><span class="kw">fread</span>(<span class="st">&quot;https://www.datalocation.com&quot;</span>)</a>
<a class="sourceLine" id="cb4-12" data-line-number="12">  <span class="cf">if</span>(save.raw<span class="op">==</span><span class="ot">TRUE</span>){</a>
<a class="sourceLine" id="cb4-13" data-line-number="13">    <span class="kw">write.csv</span>(<span class="st">&quot;my_data.csv&quot;</span>)</a>
<a class="sourceLine" id="cb4-14" data-line-number="14">  }</a>
<a class="sourceLine" id="cb4-15" data-line-number="15"><span class="kw">return</span>(x)</a>
<a class="sourceLine" id="cb4-16" data-line-number="16">}</a></code></pre></div>
<p><code>roxygen2</code> automatically creates the appropriate fields. <code>@param</code> fields are created for every parameter specified in your function, along with the <code>@return</code> field that indicates the class of the returned object, <code>@export</code> which makes sure your function is available to users when bundled into a package, and <code>@examples</code> in case you want to provide brief example to the user in the help documentation.</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb5-1" data-line-number="1"><span class="co">#&#39; Acquire the Data</span></a>
<a class="sourceLine" id="cb5-2" data-line-number="2"><span class="co">#&#39;</span></a>
<a class="sourceLine" id="cb5-3" data-line-number="3"><span class="co">#&#39; @param x Name for the returned \code{data frame}.</span></a>
<a class="sourceLine" id="cb5-4" data-line-number="4"><span class="co">#&#39; @param save.raw Logical switch indicating if the user would like to save a local copy of the file.</span></a>
<a class="sourceLine" id="cb5-5" data-line-number="5"><span class="co">#&#39;</span></a>
<a class="sourceLine" id="cb5-6" data-line-number="6"><span class="co">#&#39; @return Returns an object of class `data frame` / `data.table`.</span></a>
<a class="sourceLine" id="cb5-7" data-line-number="7"><span class="co">#&#39; @export</span></a>
<a class="sourceLine" id="cb5-8" data-line-number="8"><span class="co">#&#39;</span></a>
<a class="sourceLine" id="cb5-9" data-line-number="9"><span class="co">#&#39; @examples</span></a>
<a class="sourceLine" id="cb5-10" data-line-number="10">getData&lt;-<span class="cf">function</span>(x, <span class="dt">save.raw =</span> <span class="ot">TRUE</span>){</a>
<a class="sourceLine" id="cb5-11" data-line-number="11">  x&lt;-data.table<span class="op">::</span><span class="kw">fread</span>(<span class="st">&quot;https://www.datalocation.com&quot;</span>)</a>
<a class="sourceLine" id="cb5-12" data-line-number="12">  <span class="cf">if</span>(save.raw<span class="op">==</span><span class="ot">TRUE</span>){</a>
<a class="sourceLine" id="cb5-13" data-line-number="13">    <span class="kw">write.csv</span>(<span class="st">&quot;my_data.csv&quot;</span>)</a>
<a class="sourceLine" id="cb5-14" data-line-number="14">  }</a>
<a class="sourceLine" id="cb5-15" data-line-number="15"><span class="kw">return</span>(x)</a>
<a class="sourceLine" id="cb5-16" data-line-number="16">}</a></code></pre></div>
</div>

<footer>

<h1> Additional Meta-Data </h1>

<div id="related-packages-block">
<h3> Related Packages: </h3>
<ul>
<li>danteSubmit</li>
</ul>
</div>



<div id="related-vignettes-block">
<h3> Related Vignettes: </h3>
<ul>
<li>Submitting a vignette to the DANTE Project</li>
<li>Submitting a dataset to the DANTE Project</li>
</ul>
</div>

</footer>

</body>

</html>
